'+-----------------------------------------------------------------------------+
'|                                                                             |
'| Autor: Jonas Eberhard   www.joseng.de                                       |
'| Datei: DMX LED Dimmer 8 Kanal.bas                                           |
'| Beschreibung: 8 Kanal LED PWM Dimmer                                        |
'|                                                                             |
'+-----------------------------------------------------------------------------+

$regfile = "m8def.dat"                                      'ATMega 8
$crystal = 16000000                                         '16MHz Quarz
$baud = 250000                                              'Baudrate 250Kbaud


'Timer konfigurieren
Config Timer0 = Timer , Prescale = 8
On Timer0 Timer0_isr
Enable Timer0


'Subs
Declare Sub Adresse_basteln()

'IOs
Config Portc.0 = Input                                      'Adresse Bit 0
Config Portd.4 = Input                                      'Adresse Bit 1
Config Portc.1 = Input                                      'Adresse Bit 2
Config Portd.3 = Input                                      'Adresse Bit 3
Config Portc.2 = Input                                      'Adresse Bit 4
Config Portd.2 = Input                                      'Adresse Bit 5
Config Portc.3 = Input                                      'Adresse Bit 6
Config Portc.4 = Input                                      'Adresse Bit 7
Config Portc.5 = Input                                      'Adresse Bit 8

Config Portd.1 = Output                                     'PWM Kanal 1
Config Portd.5 = Output                                     'PWM Kanal 2
Config Portb.4 = Output                                     'PWM Kanal 3
Config Portd.6 = Output                                     'PWM Kanal 4
Config Portb.3 = Output                                     'PWM Kanal 5
Config Portd.7 = Output                                     'PWM Kanal 6
Config Portb.2 = Output                                     'PWM Kanal 7
Config Portb.0 = Output                                     'PWM Kanal 8
Config Portb.1 = Output                                     'PWM Kanal 9

Config Portb.5 = Output                                     'Statusled


'PullUps setzten
Set Portc.0
Set Portd.4
Set Portc.1
Set Portd.3
Set Portc.2
Set Portd.2
Set Portc.3
Set Portc.4
Set Portc.5


'Aliases
Statusled Alias Portb.5

Adressbit0 Alias Pinc.0
Adressbit1 Alias Pind.4
Adressbit2 Alias Pinc.1
Adressbit3 Alias Pind.3
Adressbit4 Alias Pinc.2
Adressbit5 Alias Pind.2
Adressbit6 Alias Pinc.3
Adressbit7 Alias Pinc.4
Adressbit8 Alias Pinc.5

Kanal1 Alias Portd.1                                        'PWM Kanal 1
Kanal2 Alias Portd.5                                        'PWM Kanal 2
Kanal3 Alias Portb.4                                        'PWM Kanal 3
Kanal4 Alias Portd.6                                        'PWM Kanal 4
Kanal5 Alias Portb.3                                        'PWM Kanal 5
Kanal6 Alias Portd.7                                        'PWM Kanal 6
Kanal7 Alias Portb.2                                        'PWM Kanal 7
Kanal8 Alias Portb.0                                        'PWM Kanal 8
Kanal9 Alias Portb.1                                        'PWM Kanal 8


'Funktionsvariablen
Dim Adresse As Integer                                      'Variable zum zusammenbasteln der DMX-Adresse
Dim Zaehler As Byte                                         'Zhlervariable fr die PWM
Dim Dmxkanal(9) As Byte                                     'Dmxwerte der einzelnen Kanle
Const Timervorgabe0 = 177

'DMX Variablen
Dim Dmx_count As Word                                       'Pakete die auf Ausgnge zielen
Dim Dmx_count_temp As Byte                                  'Gesendete Pakete
Dim Dmx_byte As Byte                                        'DMX Wert
Dim Dmx_clock As Byte                                       'Spielerei
Dim Dmx_adr As Word                                         'DMX-Adresse
Dim Dmx_adr_temp As Byte                                    'DMX-Adresse (Temp)
Dim Dmx_adr_c As Word                                       'DMX-Adresse (Counter)
Dim Dmx_off As Byte                                         'DMX-Signal noch da?

'Startwerte setzen
Set Statusled


' Uart initialiesieren
On Urxc Rec_isr
Enable Urxc

'UART TX Pin ausschalten
Reset Ucsrb.txen

'Anfangsvariablen Festlegen
Dmx_count = 0                                               'kein Paket empfangen
Dmx_clock = 16                                              '

Enable Interrupts

' ******************************************************************************
' Hauptschleife
' ******************************************************************************
 Do
    Waitms 10
    Decr Dmx_off
    If Dmx_off = 0 Then
       Reset Statusled
    End If
    Call Adresse_basteln
 Loop

' ******************************************************************************
' Funktion: DMX-Signal emfangen und auswerten
'           Dieser Interupt wird beim eintreffen von seriellen Daten ausgefhrt
Rec_isr:
   $asm                                                     'Programmteil fr das Auswerten der
      .def Uart_status = R16                                'emfangenen Daten
      .def Uart_byte = R17
      .def Uart_temp1 = R18

            IN Uart_status,USR
            IN Uart_byte,UDR

            SBRC Uart_status,FE                             'Auswertung ob Datenbyte OK
            RJMP  Asm_reset                                 'bei berlnge des Datenbyte = DMX Reset
            RJMP  Asm_Loop1                                 'Daten OK--->

      Asm_reset:
            LDI Uart_temp1,$00                              'Adesszhler zurcksetzen
            STS {Dmx_count_temp} , Uart_temp1               'Daten dem Basicvariablen bergeben
            STS {Dmx_byte} , Uart_byte
            RJMP Asm_exit
      Asm_loop1:
            STS {Dmx_byte} , Uart_byte
      Asm_exit:
   $end Asm

   If Dmx_count_temp <> 0 Then                              'emfangene Daten im "Dmx_buf" ablegen
      Incr Dmx_count                                        'und den jeweiligen Kanal zuordnen
      If Dmx_adr_c = Dmx_count Then
         If Dmx_adr_temp < 10 Then
            Dmxkanal(dmx_adr_temp) = Dmx_byte
            Incr Dmx_adr_temp
            Incr Dmx_adr_c
         End If
      End If
   Else                                                     'bei DMX Reset Variablen setzen
      Dmx_count = 0 : Dmx_count_temp = 1
      Dmx_adr_c = Dmx_adr + 1 : Dmx_adr_temp = 1
      Decr Dmx_clock
      'nur eine Spielerei Toggelt eine LED am PortD.6 beim eintreffen von korrekten DMX Daten
      If Dmx_clock = 0 Then : Toggle Statusled : Dmx_clock = 16 : End If
   End If
   Dmx_off = 20
Return


Sub Adresse_basteln
  'Adresse zusammenbasteln
  Adresse = 0
  If Adressbit0 = 0 Then Adresse = Adresse + 1
  If Adressbit1 = 0 Then Adresse = Adresse + 2
  If Adressbit2 = 0 Then Adresse = Adresse + 4
  If Adressbit3 = 0 Then Adresse = Adresse + 8
  If Adressbit4 = 0 Then Adresse = Adresse + 16
  If Adressbit5 = 0 Then Adresse = Adresse + 32
  If Adressbit6 = 0 Then Adresse = Adresse + 64
  If Adressbit7 = 0 Then Adresse = Adresse + 128
  If Adressbit8 = 0 Then Adresse = Adresse + 256

  'Adresse speichern
  Dmx_adr = Adresse
End Sub


'Timer0 Interruptziel
Timer0_isr:

  'Timer wieder einstellen
  Timer0 = Timervorgabe0

  'Zhler erhhen
  Incr Zaehler

  'PWM
  If Zaehler < Dmxkanal(1) Then : Set Kanal1 : Else : Reset Kanal1 : End If
  If Zaehler < Dmxkanal(2) Then : Set Kanal2 : Else : Reset Kanal2 : End If
  If Zaehler < Dmxkanal(3) Then : Set Kanal3 : Else : Reset Kanal3 : End If
  If Zaehler < Dmxkanal(4) Then : Set Kanal4 : Else : Reset Kanal4 : End If
  If Zaehler < Dmxkanal(5) Then : Set Kanal5 : Else : Reset Kanal5 : End If
  If Zaehler < Dmxkanal(6) Then : Set Kanal6 : Else : Reset Kanal6 : End If
  If Zaehler < Dmxkanal(7) Then : Set Kanal7 : Else : Reset Kanal7 : End If
  If Zaehler < Dmxkanal(8) Then : Set Kanal8 : Else : Reset Kanal8 : End If
  If Zaehler < Dmxkanal(9) Then : Set Kanal9 : Else : Reset Kanal9 : End If

Return